//	chromium clicky  -  chcl

#include <stdio.h>
#include <string.h>
#include <X11/Xlib.h>


// screen size
#define SCREEN_SIZE_X 1024
#define SCREEN_SIZE_Y 600


// x's coordinates on download bar
#define DL_BAR_X SCREEN_SIZE_X-20
#define DL_BAR_Y SCREEN_SIZE_Y-25


void
click_ptr (Display *display, int button)
{
  XEvent event;
  memset (&event, 0, sizeof (event));
  event.xbutton.button = button;
  event.xbutton.same_screen = True;
  event.xbutton.subwindow = DefaultRootWindow (display);
  while (event.xbutton.subwindow)
    {
      event.xbutton.window = event.xbutton.subwindow;
      XQueryPointer (display, event.xbutton.window,
		     &event.xbutton.root, &event.xbutton.subwindow,
		     &event.xbutton.x_root, &event.xbutton.y_root,
		     &event.xbutton.x, &event.xbutton.y,
		     &event.xbutton.state);
    }

  event.type = ButtonPress;
  XSendEvent (display, PointerWindow, True, ButtonPressMask, &event);
  event.type = ButtonRelease;
  XSendEvent (display, PointerWindow, True, ButtonReleaseMask, &event);
}


void
warp_ptr (Display *display, int x, int y)
{
  XWarpPointer (display, None, None, 0,0,0,0, (SCREEN_SIZE_X-1)*-1, (SCREEN_SIZE_Y-1)*-1);
  XWarpPointer (display, None, None, 0,0,0,0, x, y);
}


void
query_ptr (Display *display, int *x, int *y)
{
  XEvent event;
  XQueryPointer (display, DefaultRootWindow (display),
                 &event.xbutton.root, &event.xbutton.window,
                 &event.xbutton.x_root, &event.xbutton.y_root,
                 &event.xbutton.x, &event.xbutton.y,
                 &event.xbutton.state);

  *x = event.xbutton.x;
  *y = event.xbutton.y;
}


int
main ()
{ 
  int x, y;

  Display *display = XOpenDisplay (NULL);
  if (display == NULL)
      return -1;
  
  query_ptr (display, &x, &y);
  warp_ptr (display, DL_BAR_X, DL_BAR_Y);
  click_ptr (display, Button1);
  warp_ptr (display, x, y);

  XCloseDisplay (display);
  return 0;
}
